---
title: EventTarget
slug: Web/API/EventTarget
tags:
  - API
  - DOM
  - DOM Events
  - EventTarget
  - Interface
---
<nav>{{ApiRef("DOM Events")}}</nav>

<p><span class="seoSummary"><strong><code>EventTarget</code></strong> is a DOM interface implemented by objects that can receive events and may have listeners for them.</span></p>

<p>{{domxref("Element")}}, {{domxref("Document")}}, and {{domxref("Window")}} are the most common event targets, but other objects can be event targets, too. For example {{domxref("XMLHttpRequest")}}, {{domxref("AudioNode")}}, {{domxref("AudioContext")}}, and others.</p>

<p>Many event targets (including elements, documents, and windows) also support setting <a href="/en-US/docs/Web/Guide/DOM/Events/Event_handlers">event handlers</a> via <code>on<var>event</var></code> properties and attributes.</p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Constructor">Constructor</h2>

<dl>
	<dt>{{domxref("EventTarget.EventTarget()", "EventTarget()")}}</dt>
	<dd>Creates a new <code>EventTarget</code> object instance.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
	<dt>{{domxref("EventTarget.addEventListener()", "<var>EventTarget</var>.addEventListener()")}}</dt>
	<dd>Registers an event handler of a specific event type on the <code><var>EventTarget</var></code>.</dd>
	<dt>{{domxref("EventTarget.removeEventListener()", "<var>EventTarget</var>.removeEventListener()")}}</dt>
	<dd>Removes an event listener from the <code><var>EventTarget</var></code>.</dd>
	<dt>{{domxref("EventTarget.dispatchEvent()", "<var>EventTarget</var>.dispatchEvent()")}}</dt>
	<dd>Dispatches an event to this <code><var>EventTarget</var></code>.</dd>
</dl>

<h3 id="Additional_methods_in_Mozilla_chrome_codebase">Additional methods in Mozilla chrome codebase</h3>

<p>Mozilla includes a couple of extensions for use by JS-implemented event targets to implement <code>on<var>event</var></code> properties.</p>

<p>See also <a href="/en-US/docs/Mozilla/WebIDL_bindings">WebIDL bindings</a>.</p>

<ul>
	<li><code>void <strong>setEventHandler</strong>(DOMString <var>type</var>, EventHandler <var>handler</var>)</code> {{non-standard_inline}}</li>
	<li><code>EventHandler <strong>getEventHandler</strong>(DOMString <var>type</var>)</code> {{non-standard_inline}}</li>
</ul>

<h2 id="Example">Example</h2>

<h3 id="Simple_implementation_of_EventTarget">Simple implementation of EventTarget</h3>

<pre class="brush: js notranslate">var EventTarget = function() {
  this.listeners = {};
};

EventTarget.prototype.listeners = null;
EventTarget.prototype.addEventListener = function(type, callback) {
  if (!(type in this.listeners)) {
    this.listeners[type] = [];
  }
  this.listeners[type].push(callback);
};

EventTarget.prototype.removeEventListener = function(type, callback) {
  if (!(type in this.listeners)) {
    return;
  }
  var stack = this.listeners[type];
  for (var i = 0, l = stack.length; i &lt; l; i++) {
    if (stack[i] === callback){
      stack.splice(i, 1);
      return;
    }
  }
};

EventTarget.prototype.dispatchEvent = function(event) {
  if (!(event.type in this.listeners)) {
    return true;
  }
  var stack = this.listeners[event.type].slice();

  for (var i = 0, l = stack.length; i &lt; l; i++) {
    stack[i].call(this, event);
  }
  return !event.defaultPrevented;
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('DOM WHATWG', '#interface-eventtarget', 'EventTarget')}}</td>
			<td>{{Spec2('DOM WHATWG')}}</td>
			<td>No change.</td>
		</tr>
		<tr>
			<td>{{SpecName('DOM3 Events', 'DOM3-Events.html#interface-EventTarget', 'EventTarget')}}</td>
			<td>{{Spec2('DOM3 Events')}}</td>
			<td>A few parameters are now optional (<code><var>listener</var></code>), or accepts the <code>null</code> value (<code><var>useCapture</var></code>).</td>
		</tr>
		<tr>
			<td>{{SpecName('DOM2 Events', 'events.html#Events-EventTarget', 'EventTarget')}}</td>
			<td>{{Spec2('DOM2 Events')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.EventTarget")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/Reference/Events">Event reference</a> - the events available in the platform.</li>
	<li><a href="/en-US/docs/Web/Guide/DOM/Events">Event developer guide</a></li>
	<li>{{domxref("Event")}} interface</li>
</ul>
